include \masm32\include\masm32rt.inc

inv EQU invoke

DlgProc PROTO hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

.list

.data?
hWin  dd ?
buff  db 100 dup (?)
ps  PAINTSTRUCT <>
hdc HDC ?
mDC HDC ?

hBmp1   dd ?
hBmp2   dd ?
hBmp3   dd ?
hBmp4   dd ?
;;;
hBmpMask  dd ?
;;;
btmap   BITMAP <>
strtx   dd ?
strty   dd ?
.data
file1 db 'Bitmap_1.bmp',0
file2 db 'Bitmap_2.bmp',0
file3 db 'Bitmap_3.bmp',0
file4 db 'Bitmap_4.bmp',0
;;;
fileMask db 'mask.bmp',0 
;;;
.code
Program:
    inv InitCommonControls
    inv GetModuleHandle,0
    inv DialogBoxParam,eax,101,0,DlgProc, 0
    inv ExitProcess, eax

Loadbmp proc indx,filename
    inv LoadImage,0,filename,IMAGE_BITMAP,0,0,LR_LOADFROMFILE
    mov ecx,indx
    mov hBmp1[ecx*4-4],eax
	ret
Loadbmp endp
Showbmp proc indx
    mov eax,indx
    inv SelectObject,mDC,hBmp1[eax*4-4]
    ;inv BitBlt,hdc,strtx,strty,btmap.bmWidth, btmap.bmHeight ,mDC,0,0,SRCCOPY

;#define MAKEROP4(fore,back) (DWORD)((((back) << 8) & 0xFF000000) | (fore))

    inv MaskBlt,hdc,strtx,strty,btmap.bmWidth, btmap.bmHeight ,mDC,0,0,
                hBmpMask,0,0,((MERGEPAINT SHL 8) AND 0ff000000h) OR SRCCOPY
comment |
BOOL MaskBlt(
  HDC hdcDest,     // handle to destination DC
  int nXDest,      // x-coord of destination upper-left corner
  int nYDest,      // y-coord of destination upper-left corner 
  int nWidth,      // width of source and destination
  int nHeight,     // height of source and destination
  HDC hdcSrc,      // handle to source DC
  int nXSrc,       // x-coord of upper-left corner of source
  int nYSrc,       // y-coord of upper-left corner of source
  HBITMAP hbmMask, // handle to monochrome bit mask
  int xMask,       // horizontal offset into mask bitmap
  int yMask,       // vertical offset into mask bitmap
  DWORD dwRop      // raster operation code
);

BOOL BitBlt(
  HDC hdcDest, // handle to destination DC
  int nXDest,  // x-coord of destination upper-left corner
  int nYDest,  // y-coord of destination upper-left corner
  int nWidth,  // width of destination rectangle
  int nHeight, // height of destination rectangle
  HDC hdcSrc,  // handle to source DC
  int nXSrc,   // x-coordinate of source upper-left corner
  int nYSrc,   // y-coordinate of source upper-left corner
  DWORD dwRop  // raster operation code
);
|
    mov eax,btmap.bmWidth
    ;add strtx,eax
    add strtx,20
    add strty,20
	ret
Showbmp endp    
DlgProc proc hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
    .if uMsg == WM_COMMAND
        ;.if    wParam == buttonid
        ;.endif
    .elseif uMsg== WM_INITDIALOG
        mov eax,hWnd    ; save handle for everyone
        mov hWin,eax
        inv Loadbmp,1,addr file1
        inv Loadbmp,2,addr file2
        inv Loadbmp,3,addr file3
        inv Loadbmp,4,addr file4

        inv Loadbmp,5,addr fileMask

    .elseif uMsg==WM_PAINT
        inv BeginPaint,hWnd,ADDR ps
        mov hdc,eax
        inv CreateCompatibleDC,eax
        mov mDC,eax

        mov strtx,0
        mov strty,0
        inv GetObject,hBmp1,sizeof btmap,addr btmap
        
        inv Showbmp,1
        inv Showbmp,2
        inv Showbmp,3
        inv Showbmp,4

        inv DeleteDC,mDC
        inv EndPaint,hWnd,ADDR ps
    .elseif uMsg == WM_CLOSE
        inv DeleteObject,hBmp1
        inv DeleteObject,hBmp2
        inv DeleteObject,hBmp3
        inv DeleteObject,hBmp4
        inv EndDialog,hWin,0
    .endif

    xor eax,eax
    ret
DlgProc endp

end Program